# Copyright (C) 1999, 2000
# by Juergen Pfeifer <juergen@gnuada.org>
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
# Author: Juergen Pfeifer <juergen@gnuada.org>
# ---------------------------------------------------------------------------
# GNU Ada RPM Packaging
#
# This specification file is generated using a m4 based macrosystem.
# Please don't change it directly but get instead the macro system
# and change the input files of this system. 
# ---------------------------------------------------------------------------
#
%define        PKG_TARGET_OS       Linux
%define        TARGET_OS           linux
%define        TARGET_ARCH         i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        DEF_USER            bin
%define        DEF_GROUP           bin
%define        CFG_PREFIX          /usr
#
%define        AUTHOR_NAME         Juergen Pfeifer
%define        AUTHOR_MAIL	   juergen.pfeifer@gmx.net
#
%define        GNAT_BASE_VERSION   3.12
%define        GNAT_PKG_VERSION    3.12p
%define        GNAT_PKG_RELEASE    11
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
%define        GLIBC_VERSION	   2.1
%define        GNAT_VERSION        3.12p
%define        BASE_VERSION        gcc-%{GCC_VERSION}
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat
%define        GNATRT_PKG_NAME     gnat-3.12p-runtime
%define        GNATRT_PKG_VERSION  1
#
%define        ADA_ROOT            /lib/ada
%define        ADA_BASE            %{CFG_PREFIX}%{ADA_ROOT}
%define        SHARE_BASE	   /share/ada
%define        ADA_SHARE           %{CFG_PREFIX}%{SHARE_BASE}
#
%define        HTML_BASE	   %{SHARE_BASE}/html
%define        ADA_HTML	           %{CFG_PREFIX}%{HTML_BASE}
#
%define        GNAT_SO_MAJOR       1
%define        GNAT_SO_MINOR       %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS         -O3 -m486
%define        RPM_ADA_FLAGS       -gnatpn
#
%define        THREADLIBS          -lpthread
#
%define        DOC_BASE            %{CFG_PREFIX}/doc
#
%define        GNAT_ALIAS          %{BASE_NAME}
%define        GNAT_NAME           %{GNAT_ALIAS}-%{GNAT_VERSION}
%define        GNAT_SO             %{GNAT_NAME}
#
%define        GNARL_ALIAS         gnarl
%define        GNARL_NAME          %{GNARL_ALIAS}-%{GNAT_VERSION}
%define        GNARL_SO            %{GNARL_NAME}
#
%define        AINC_NAME           adainclude
%define        AINC_DIR            %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME           adalib
%define        ALIB_DIR            %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME            etc
%define        ETC_DIR             %{ADA_BASE}/%{ETC_NAME}
%define        EMACS_DIR           %{ADA_ROOT}/%{ETC_NAME}/adamode
%define        ADAMODE_DIR         %{CFG_PREFIX}%{EMACS_DIR}
%define        INFO_NAME           %{ADA_ROOT}/info
%define        INFO_DIR            %{CFG_PREFIX}%{INFO_NAME}
#
%define        ASIS_ALIAS          asis
%define        ASIS_NAME           %{ASIS_ALIAS}-%{GNAT_VERSION}
%define        ASIS_SO             %{ASIS_NAME}
%define        ASIS_DIR            %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_ALIAS         garlic
%define        GLADE_NAME          garlic-%{GNAT_VERSION}
%define        GLADE_SO            garlic-%{GNAT_VERSION}
%define        GLADE_DIR           %{ADA_BASE}/%{GLADE_NAME}
#
%define        FLORIST_ALIAS       florist
%define        FLORIST_NAME        %{FLORIST_ALIAS}-%{GNAT_VERSION}
%define        FLORIST_SO          %{FLORIST_NAME}
#
%define        GNAT_GCC            gnatgcc
#
%define PKG_NAME    gnat
%define PKG_VERSION 3.12p
%define PKG_RELEASE 11mdk
# 
# If there is a runtime package, it has this name
%define PKGRT_NAME  gnat-runtime
#
# Name of development package in the old scheme
%define OLD_DEVPKG_NAME gnat-devel-3.12p
%define OLD_RTNAME      gnat-3.12p
#
# ---------------------------------------------------------------------------
# We restrict the use of this package script at the moment to Intel and
# Linux. For sure there are details (compiler options, shared library
# building) that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{PKG_TARGET_OS}
#Vendor:        Ada for Linux Team (ALT)
Packager:      Juergen Pfeifer
#Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     %{_builddir}/%{PKG_NAME}_glibc%{GLIBC_VERSION}-%{version}-root
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
#
# Some local defines
%define GNAT_SRC       gnat-%{GNAT_VERSION}-src
%define GDOC_SRC       gnat-%{GNAT_VERSION}-docs
%define GLADE_SRC      glade-%{GNAT_VERSION}-src
%define ASIS_SRC       asis-%{GNAT_VERSION}-src
%define FLORIST_SRC    florist-%{GNAT_VERSION}-src
#
%define ADAMODE_VERS     3.4a
%define BUILD_LANGUAGES  "c ada"
#
#  Please note that this package is intentionally build on base of gcc-2.8.1
#  We intend to provide a stable Ada95 compiler and gcc-2.8.1 is the platform
#  used by ACT to build and test the system.
#
# These are the official sources
Source0:       ftp://ftp.gnu.org/gnu/gcc/%{BASE_VERSION}.tar.gz 
Source1:       ftp://ftp.cs.nyu.edu/pub/gnat/%{GNAT_SRC}.tar.gz
Source2:       ftp://ftp.cs.nyu.edu/pub/gnat/%{GDOC_SRC}.tar.gz
Source3:       ftp://ftp.cs.nyu.edu/pub/gnat/glade/%{GLADE_SRC}.tar.gz
Source4:       ftp://ftp.cs.nyu.edu/pub/gnat/asis/%{ASIS_SRC}.tar.gz
Source5:       ftp://ftp.cs.nyu.edu/pub/gnat/florist/%{FLORIST_SRC}.tar.gz
Source9:       http://www.ada-france.org/ada-mode/adamode-%{ADAMODE_VERS}.tar.gz
Source10:      ftp://ftp.gnu.org/gnu/gdb/gdb-%{GDB_VERSION}.tar.gz
Source11:      ftp://ftp.cs.nyu.edu/pub/gnat/gdb/gdb-%{GDB_VERSION}.gnat.%{GNAT_VERSION}-docs.tar.gz
Source12:      http://www.adapower.com/reuse/getopt_pkg.adb
Source13:      ftp://ftp.adapower.com/pub/rm95html.zip
Source14:      ftp://ftp.adapower.com/pub/rat95html-1.07.tar.gz
#
# And this is our stuff
Source20:      alt-roots.tar.gz
Source21:      README.Linux.glibc-%{GLIBC_VERSION}.html
Source22:      %{BASE_NAME}-FHS-Proposal
Source23:      %{BASE_NAME}.sh.in
Source24:      %{BASE_NAME}.csh.in
Source25:      %{BASE_NAME}-rts.sh.in
Source26:      %{BASE_NAME}-rts.csh.in
Source27:      gnat.1
Source28:      README.ALT.emacs
Source29:      ada95qas.tar.gz
Source30:      althtml
Source31:      index.html.in
Source32:      gnat_addr2line
#
# This is an official patch
Patch0:        ftp://ftp.yggdrasil.com/private/hjl/gdb-4.17-4.17.0.11.diff.gz
#
# And these are our patches
Patch20:       gcc281.patch
Patch21:       gnat312p.patch
Patch22:       gnat312p-docs.patch
Patch23:       glade312p.patch
Patch24:       asis312p.patch
Patch25:       florist312p.patch
Patch26:       adamode-%{ADAMODE_VERS}.diff
Patch30:       gdb-%{GDB_VERSION}.gnat312p.alt.diff.gz
#
# We don't include these sources and patches into the source RPM.
# You can get them yourself from the internet and copy them to
# your /usr/src/redhat/SOURCES directory ($RPM_SOURCE_DIR).
# Or you can try the ftp options of rpm :-)
# Otherwise our .src.rpm file would become approx. 25MB
#
NoSource:  0
NoSource:  1
NoSource:  2
NoSource:  3
NoSource:  4
NoSource:  5
NoSource:  9
NoSource: 10
NoSource: 11
NoSource: 12
NoSource: 13
NoSource: 14
#
#  ---------------------------------------------------------------------------
URL:           http://www.gnat.com/
#
Copyright:     GPL (modified for runtime)
Summary:       GNU Ada95 Compiler based on gcc (GNAT)
Summary(de):   GNU Ada95 Compiler basierend auf dem gcc (GNAT)
Summary(fr):   Compilateur GNU Ada95 bas sur GCC (GNAT)
Group:         Development/Other
Obsoletes:     %{name}
Conflicts:     %{OLD_DEVPKG_NAME}
Requires:      %{GNATRT_PKG_NAME} = %{GNATRT_PKG_VERSION}
Requires:      binutils >= 2.9.1
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description
This package contains an Ada95 compiler and associated development tools
based on the GNU gcc technology. Ada95 is the object oriented successor 
of the Ada83 language. To build this package from sources you must have 
installed a binary version to bootstrap the compiler.
#
%description -l de
Dieses Paket enthlt einen auf der GNU gcc Technologie basierenden Ada95
Compiler und dazugehrige weitere Entwicklungswerkzeuge. Ada95 ist die 
objektorientierte Nachfolgesprache von Ada83. Um dieses Paket aus den 
Quellen zu erstellen, bentigen sie die binre Version (Bootstrap).
#
%description -l fr
Ce paquetage contient un compilateur Ada95 et des outils associs de
dveloppement bass sur la technologie GNU gcc. Ada95 est le successeur
orient-objet du langage Ada83. Pour construire ce paquetage  partir
des sources, vous devez avoir install une version binaire pour amorcer
le compilateur.
#
#  ---------------------------------------------------------------------------
%package -n %{GNATRT_PKG_NAME}
#
Autoreq:       No
Autoreqprov:   No
Summary:       Runtime libraries for GNU Ada compiler (GNAT)
Summary(de):   Laufzeit-Bibliotheken des GNU Ada Compilers (GNAT)
Summary(fr):   Bibliothques partages du compilateur GNU Ada (GNAT)
Group:         Development/Other
Version:       %{GNATRT_PKG_VERSION}
Obsoletes:     %{GNATRT_PKG_NAME}
Conflicts:     %{OLD_RTNAME}
Provides:      lib%{GNAT_SO}.so.%{GNAT_SO_MAJOR}
Provides:      lib%{GNARL_SO}.so.%{GNAT_SO_MAJOR}
Provides:      lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}
Provides:      lib%{ASIS_SO}.so.%{GNAT_SO_MAJOR}
Provides:      lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR}
Requires:      libc.so.6 ld-linux.so.2
Icon:          adarts.gif
Prefix:        %{CFG_PREFIX}
#
%description -n %{GNATRT_PKG_NAME}
This package contains the shared libraries required to run programs compiled
with the GNU Ada compiler (GNAT) if they are compiled to use shared libraries.
It also contains the shared libraries for the Implementation of the Ada 
Semantic Interface Specification (ASIS), the implementation of Distributed
Systems  Programming (GLADE) and the Posix 1003.5 Binding (Florist).
#
%description -l de -n %{GNATRT_PKG_NAME}
Dieses Paket enthlt die Shared Libraries die zur Ausfhrung von Programmen
bentigt werden, die mit dem GNU Ada Compiler (GNAT) erzeugt wurden und
diese so bersetzt wurden, dass sie die Shared Libraries benutzen. Es enthlt
zudem die shared Libraries fr die Implementierung der Ada Semantic Interface
Specification (ASIS), die Implementierung des Progammierens von verteilten
Systemen (GLADE) und das Posix 1003.5 Binding (Florist).
#
%description -l fr -n %{GNATRT_PKG_NAME}
Ce paquetage contient les bibliothques partages ncessaires  l'excution
des programmes compils avec le compilateur GNU Ada (GNAT) lorsqu'ils ont t
compils pour utiliser les bibliothques partages. Il contient aussi les
bibliothques partages de l'implmentation de la Spcification de l'Interface
Smantique du langage Ada (ASIS), de l'implmentation de la Programmation des
Systmes Distribus (GLADE) et du Binding Posix 1003.5 (Florist).
#
#  ---------------------------------------------------------------------------
%package -n gnat-glade
#
Autoreq:       No
Autoreqprov:   No
Summary:       GNU Ada95 Distributed Systems Programming
Summary(de):   GNU Ada95 Programmierung verteilter Systeme
Summary(fr):   Programmation des Systmes Distribus GNU Ada95
Group:         Development/Other
Obsoletes:     gnat-glade
Conflicts:     gnat-glade-%{GNAT_VERSION}
Requires:      %{GNAT_PKG_NAME} = %{PKG_VERSION}
Requires:      %{GNATRT_PKG_NAME} = %{GNATRT_PKG_VERSION}
Icon:          adaglade.gif
Prefix:        %{CFG_PREFIX}
#
%description -n gnat-glade
This package contains the tools und development libraries required to
write GNU Ada programs using the distributed system annex.
#
%description -l de -n gnat-glade
Dieses Paket enthlt die Werkzeuge und Entwicklungsbibliotheken die bentigt
werden, um Programme gem dem Distributed System Annex zu schreiben.
#
%description -l fr -n gnat-glade
Ce paquetage contient les outils et les bibliothques de dveloppement
ncessaires  l'criture de programmes utilisant l'annexe des systmes
distribus.
#
#  ---------------------------------------------------------------------------
%package -n florist
#
Autoreq:       No
Autoreqprov:   No
Summary:       GNU Ada95 Posix 1003.5 Implementation
Summary(de):   GNU Ada95 Posix 1003.5 Implementierung
Summary(fr):   Implmentation GNU Ada95 de Posix 1003.5
Group:         Development/Other
Obsoletes:     florist
Conflicts:     florist-%{GNAT_VERSION}
Requires:      %{GNAT_PKG_NAME} = %{PKG_VERSION}
Icon:          adaflorist.gif
Prefix:        %{CFG_PREFIX}
#
%description -n florist
This is a set of Ada packages that allows you to write programs using the
Florida State Universities (FSU) implementation of the Posix 1003.5 
standard for GNU Ada (GNAT). This project has the codename FLORIST.
Posix 1003.5 is the Posix standard for how to bind the Posix functions
to Ada. This is what you need if you want to call OS functions from
Ada programs directly.
#
%description -l de -n florist
Dies ist ein Sammlung von Ada Pakten die es Ihnen erlaubt, GNU Ada (GNAT)
Programme mit der Implementierung des Posix 1003.5 Standards der Florida
State University (FSU) zu schreiben. Dieses Projekt hat den Codenamen
FLORIST. Posix 1003.5 ist der Posix Standard der beschreibt, wie die
Posix Funktionen von Ada benutzt werden. Dies brauchen Sie, wenn Sie
Betriebssystemfuntionen direkt aus Ada Programmen aufrufen wollen.
#
%description -l fr -n florist
Ceci est un ensemble de paquetages Ada qui vous permettent d'crire des
programmes utilisant l'implmentation faite par l'Universit d'Etat de
Floride (FSU) du standard Posix 1003.5 pour le compilateur GNU Ada (GNAT).
Ce projet a pour nom de code FLORIST. Posix 1003.5 est le standard Posix
pour appeler les fonctions Posix depuis Ada. C'est ce qu'il vous faut
lorsque vous souhaitez appeler des fonctions de l'OS directement depuis
des programmes Ada.
#
#  ---------------------------------------------------------------------------
%package -n asis
#
Autoreq:       No
Autoreqprov:   No
Summary:       GNU Ada95 Ada Sematic Interface Specification Implementation
Summary(de):   GNU Ada95 Ada Sematic Interface Specification Implementierung
Summary(fr):   Implmentation GNU de la Spc. de l'Interface Smantique
Group:         Development/Other
Obsoletes:     asis
Conflicts:     asis-%{GNAT_VERSION}
Requires:      %{GNAT_PKG_NAME} = %{PKG_VERSION}
Requires:      %{GNATRT_PKG_NAME} = %{GNATRT_PKG_VERSION}
Icon:          adaasis.gif
Prefix:        %{CFG_PREFIX}
#
%description -n asis
This package contains the tools und development libraries required to
write GNU Ada programs using the Ada Semantic Interface Specification
(ASIS)
#
%description -l de -n asis
Dieses Paket enthlt die Werkzeuge und Entwicklungsbibliotheken die bentigt
werden, um Programme gem der Ada Semantic Interface Specification (ASIS)
zu schreiben.
#
%description -l fr -n asis
Ce paquetage contient les outils et les bibliothques de dveloppement
ncessaires  l'criture de programmes utilisant la Spcification de
l'Interface Smantique du langage Ada (ASIS).
#
#-----------------------------------------------------------------------------
%prep
#=============================================================================
#
# We issue a warning to remind the person doing the build that
# the binary must be installed 
cat <<EOF
------------------------------------------------------------------------

H I N T:
========

You must install the binary package for GNU Ada before you can rebuild 
this package from the sources.

This is required, because this package provides an gcc based GNU Ada95
compiler (GNAT) and it's frontend is written in Ada95 itself. So you
need a bootstrap compiler (like you need a C compiler to build gcc).

The preparation of the package build will fail now, if GNU Ada isn't
installed. Please install it and rerun the package build.

------------------------------------------------------------------------
EOF
sleep 5
#
rpm -q %{GNAT_PKG_NAME} || rpm -q gnat-3.12p-devel || rpm -q gnat-devel-3.12p || rpm -q gnat-3.11p-devel
#
%setup -q             -n %{BASE_VERSION}
%setup -q -T -D -a 1  -n %{BASE_VERSION}
%setup -q -T -D -a 2  -n %{BASE_VERSION}
%setup -q -T -D -a 3  -n %{BASE_VERSION}
%setup -q -T -D -a 4  -n %{BASE_VERSION}
%setup -q -T -D -a 5  -n %{BASE_VERSION}
%setup -q -T -D -a 9  -n %{BASE_VERSION}
%setup -q -T -D -a 10 -n %{BASE_VERSION}
%setup -q -T -D -a 11 -n %{BASE_VERSION}
#
%setup -q -T -D -a 20 -n %{BASE_VERSION}
#
%patch20 -p1 -b .gcc
%patch21 -p0 -b .gnat
%patch22 -p0 -b .docs
%patch23 -p0 -b .glade
%patch24 -p0 -b .asis
%patch25 -p0 -b .florist
%patch26 -p0 -b .adamode
#
cd gdb-%{GDB_VERSION}
%patch0 -p2 -b .hjl
%patch30 -p1 -b .gnatgdb
cd ..
#
# Move the GNAT sources ada directory under the gcc source tree
# and do what they say in the GNAT build readme.
mv %{GNAT_SRC}/src/ada .
patch -p0 < %{GNAT_SRC}/src/gcc-281.dif
#
if [ -f cstamp-h.in ]; then
  touch cstamp-h.in
fi
touch ada/treeprs.ads ada/a-[es]info.h ada/nmake.ad[bs]
touch c-gperf.h
#
# The next step is done because the gnat source patch inserts
# some variables into sources that must be replaced now
for f in ada/osint.adb
do
  mv -f ${f} ${f}.in
  sed "s:@AINC_DIR@:%{AINC_DIR}:g" < ${f}.in |\
  sed "s:@ALIB_DIR@:%{ALIB_DIR}:g" > ${f}
  rm -f ${f}.in
done
#
cd ada
cat > glibcvers.def <<EOF
GLIBC_20 := FALSE
GLIBC_21 := TRUE
EOF
rm -f 5iosinte.ads
gnatprep 5iosinte.ads_p 5iosinte.ads glibcvers.def
rm -f glibcvers.def
cd ..
#
#-----------------------------------------------------------------------------
%build
#=============================================================================
# Create the required directory structure for the binary package
#
# Get the name of the Operating System in lower case
OS=%{TARGET_OS}
#
PATH=/usr/bin:/bin:/sbin:/usr/sbin:/usr/X11R6/bin:/usr/local/bin:/usr/local/sbin
if [ "${GNAT_ROOT}" != "" ]; then
   PATH="${GNAT_ROOT}/bin:${PATH}"
fi
export PATH
#
%define ALT_BUILD_DOC  $RPM_BUILD_ROOT/doc
%define ALT_BUILD_HTML $RPM_BUILD_ROOT%{ADA_HTML}
#
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/info
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/bin
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/lib
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/doc
mkdir -p $RPM_BUILD_ROOT%{AINC_DIR}
mkdir -p $RPM_BUILD_ROOT%{ALIB_DIR}
mkdir -p $RPM_BUILD_ROOT%{GLADE_DIR}
mkdir -p $RPM_BUILD_ROOT%{ASIS_DIR}
mkdir -p $RPM_BUILD_ROOT%{ETC_DIR}
mkdir -p $RPM_BUILD_ROOT%{INFO_DIR}
mkdir -p $RPM_BUILD_ROOT%{ADA_SHARE}
mkdir -p %{ALT_BUILD_DOC}
mkdir -p %{ALT_BUILD_HTML}
#

%define GNAT_BUILD_DOC    %{ALT_BUILD_DOC}
%define GDB_BUILD_DOC     $RPM_BUILD_ROOT/gdb_doc
%define GLADE_BUILD_DOC   $RPM_BUILD_ROOT/garlic_doc
%define ASIS_BUILD_DOC    $RPM_BUILD_ROOT/asis_doc
%define FLORIST_BUILD_DOC $RPM_BUILD_ROOT/florist_doc
#
mkdir -p %{GLADE_BUILD_DOC}
mkdir -p %{GDB_BUILD_DOC}
mkdir -p %{ASIS_BUILD_DOC}
mkdir -p %{FLORIST_BUILD_DOC}/tests
mkdir -p $RPM_BUILD_ROOT%{ADAMODE_DIR}
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/man/man1
mkdir -p %{GNAT_BUILD_DOC}/examples
mkdir -p %{GNAT_BUILD_DOC}/adamode
mkdir -p %{GNAT_BUILD_DOC}/getopt
mkdir -p %{ALT_BUILD_HTML}/gnat
mkdir -p %{ALT_BUILD_HTML}/asis
mkdir -p %{ALT_BUILD_HTML}/florist
#
# First we check the version of gnat we use to build
GNATVSN=`gnatls -v | grep GNATLS | awk '{print $2;}' | sed -e "s/[A-Za-z]//g"`
#
if [ $GNATVSN != "3.12" ]; then
sed -e "s/@VERS@/${GNATVSN}/g" <<EOF
+------------------------------------------------------------------------------
| You are building GNAT 3.12 with an existing GNAT version @VERS@.
| We bootstrap now the new version using the old one.
+------------------------------------------------------------------------------
EOF
else
sed -e "s/@VERS@/${GNATVSN}/g" <<EOF
+------------------------------------------------------------------------------
| You are building GNAT 3.12 with an existing GNAT version @VERS@.
| We skip the bootstrap because you rebuild the existing version.
+------------------------------------------------------------------------------
EOF
fi
#
# recompile adamode, because we've patched it
#
cd adamode-%{ADAMODE_VERS}
cat > ./recomp <<EOF
(byte-recompile-directory ".")
EOF
chmod +x ./runemacs
./runemacs -batch -l ./recomp
rm -f ./recomp ./runemacs
cd ..
#
# We build gdb
#
cd gdb-%{GDB_VERSION}
CC="%{GNAT_GCC} -pipe" CFLAGS="-O2" \
    CONFIG_LDFLAGS="-L/usr/lib/termcap" \
   ./configure --prefix=%{CFG_PREFIX}       \
               --host=%{TARGET_ARCH}-Ada-${OS}   \
	       --target=%{TARGET_ARCH}-Ada-${OS} \
	       --build=%{TARGET_ARCH}-Ada-${OS}
#
make CC="%{GNAT_GCC} -pipe" CFLAGS="-O2"
make info
cd ..
#
# Do the gcc/gnat build in a separate directory
rm -rf obj-%{TARGET_ARCH}-${OS}
mkdir obj-%{TARGET_ARCH}-${OS}
cd obj-%{TARGET_ARCH}-${OS}
#
# For now we use the already installed GNAT compiler
# to bootstrap the new version.
CC="%{GNAT_GCC} -pipe" ; export CC
#
CFLAGS="%{RPM_C_FLAGS}"                    \
LIBGCC=libgnatgcc.a                        \
../configure  --prefix=%{CFG_PREFIX}       \
              --host=%{TARGET_ARCH}-Ada-${OS}   \
	      --target=%{TARGET_ARCH}-Ada-${OS} \
	      --build=%{TARGET_ARCH}-Ada-${OS}
#
# Now build the C and the Ada compilers and the Ada runtime (shared).
#
make    CFLAGS="%{RPM_C_FLAGS}"                                         \
	GNATLIBCFLAGS="%{RPM_C_FLAGS} -UIN_GCC"                         \
	ADAFLAGS="%{RPM_ADA_FLAGS} -gnatg"                              \
	GNATLIBFLAGS="%{RPM_ADA_FLAGS} -gnatg"                          \
	LIBGCC=libgnatgcc.a                                             \
	SO_MAJOR=%{GNAT_SO_MAJOR} SO_MINOR=%{GNAT_SO_MINOR}             \
	SO_BASE=%{GNAT_SO}                                              \
	MAKEINFO="makeinfo --no-split" LANGUAGES=%{BUILD_LANGUAGES}
#
if [ $GNATVSN != "3.12" ]; then
make    CFLAGS="%{RPM_C_FLAGS}"                                         \
	GNATLIBCFLAGS="%{RPM_C_FLAGS} -UIN_GCC"                         \
	ADAFLAGS="%{RPM_ADA_FLAGS} -gnatg"                              \
	GNATLIBFLAGS="%{RPM_ADA_FLAGS} -gnatg"                          \
	LIBGCC=libgnatgcc.a                                             \
	SO_MAJOR=%{GNAT_SO_MAJOR} SO_MINOR=%{GNAT_SO_MINOR}             \
	SO_BASE=%{GNAT_SO}                                              \
	MAKEINFO="makeinfo --no-split" LANGUAGES=%{BUILD_LANGUAGES} bootstrap
fi
#
make    CFLAGS="%{RPM_C_FLAGS}"                                         \
	GNATLIBCFLAGS="%{RPM_C_FLAGS} -UIN_GCC"                         \
	ADAFLAGS="%{RPM_ADA_FLAGS} -gnatg"                              \
	GNATLIBFLAGS="%{RPM_ADA_FLAGS} -gnatg"                          \
	LIBGCC=libgnatgcc.a                                             \
	SO_MAJOR=%{GNAT_SO_MAJOR} SO_MINOR=%{GNAT_SO_MINOR}             \
	SO_BASE=%{GNAT_SO}                                              \
	LANGUAGES=%{BUILD_LANGUAGES} gnattools
#
# First we do a regular static build
make    CFLAGS="%{RPM_C_FLAGS}"                                         \
	GNATLIBCFLAGS="%{RPM_C_FLAGS} -UIN_GCC"                         \
	ADAFLAGS="%{RPM_ADA_FLAGS} -gnatg -I-"                          \
	GNATLIBFLAGS="%{RPM_ADA_FLAGS} -gnatg"                          \
	LIBGCC=libgnatgcc.a                                             \
	SO_MAJOR=%{GNAT_SO_MAJOR} SO_MINOR=%{GNAT_SO_MINOR}             \
	SO_BASE=%{GNAT_SO}                                              \
	LANGUAGES=%{BUILD_LANGUAGES} gnatlib
#
mkdir ada/rts-save
cp -pdf ada/rts/*.a ada/rts-save
#
rm -f ada/rts/*.o ada/rts/*.ali ada/rts/*.a
rm -f stamp-gnatlib*
#
# And now we build the shared library
make    CFLAGS="%{RPM_C_FLAGS}"                                         \
	GNATLIBCFLAGS="%{RPM_C_FLAGS} -UIN_GCC"                         \
	ADAFLAGS="%{RPM_ADA_FLAGS} -gnatg -I-"                          \
	GNATLIBFLAGS="%{RPM_ADA_FLAGS} -gnatg"                          \
	LIBGCC=libgnatgcc.a                                             \
	SO_MAJOR=%{GNAT_SO_MAJOR} SO_MINOR=%{GNAT_SO_MINOR}             \
	SO_BASE=%{GNAT_SO}                                              \
	LANGUAGES=%{BUILD_LANGUAGES} gnatlib-shared
#
# The previous build produces also libgnat.a in the rts directory.
# We rename that to libgnat_so.a and save it also in the save
# directory. libgnat_so.a contains all object files compiled with
# -fPIC flag. In the save directory are now the original libraries
# as they are built by the ACT makefiles. The libraries in the rts
# directory will later be copied and modified by the GLADE build 
# process.
mv -f ada/rts/lib%{GNAT_ALIAS}.a ada/rts/lib%{GNAT_ALIAS}_so.a 
mv -f ada/rts/lib%{GNARL_ALIAS}.a ada/rts/lib%{GNARL_ALIAS}_so.a
cp -pdf ada/rts/lib%{GNAT_ALIAS}_so.a ada/rts-save/lib%{GNAT_ALIAS}_so.a
cp -pdf ada/rts/lib%{GNARL_ALIAS}_so.a ada/rts-save/lib%{GNARL_ALIAS}_so.a
cp -pdf ada/rts-save/lib%{GNAT_ALIAS}.a ada/rts/lib%{GNAT_ALIAS}.a
cp -pdf ada/rts-save/lib%{GNARL_ALIAS}.a ada/rts/lib%{GNARL_ALIAS}.a
#
# At this point we are still in the gcc/gnat build directory. For the
# following builds we use the just built C and Ada compiler and the
# Ada runtime. We store those locations in some environment variables.
#
BD="`pwd`" ; export BD
GNAT_RTS="${BD}/ada/rts" ; export GNAT_RTS
GNAT_RTS_SAVE="${BD}/ada/rts-save" ; export GNAT_RTS_SAVE
CC="${BD}/xgcc -pipe -B${BD}/" ; export CC
ADACC="${CC} -I. -I${GNAT_RTS}"; export ADACC
LD_LIBRARY_PATH="${GNAT_RTS}:${LD_LIBRARY_PATH}" ; export LD_LIBRARY_PATH
ADA_INCLUDE_PATH="${GNAT_RTS}"; export ADA_INCLUDE_PATH
ADA_OBJECTS_PATH="${GNAT_RTS}"; export ADA_OBJECTS_PATH
PATH="${BD}:${PATH}"; export PATH
#
# Because we use GNAT_RTS as LD_LIBRARY_PATH, we have to make sure
# that the shared RTS is accessible with its SONAME
CUR=`pwd`
pushd ${GNAT_RTS}
for f in gnat gnarl
do
  if [ ! -f lib${f}.so ]; then
    if [ -f lib${f}-%{GNAT_VERSION}.so ]; then
      ln -sf lib${f}-%{GNAT_VERSION}.so lib${f}-%{GNAT_VERSION}.so.%{GNAT_SO_MAJOR}
      ln -sf lib${f}-%{GNAT_VERSION}.so lib${f}.so
      ln -sf ${GNAT_RTS}/lib${f}.so ${CUR}/lib${f}.so
    else
      echo "Can't make lib${f}.so in ${GNAT_RTS}" 2>&1
      echo "Programs will be linked statically" 2>&1
    fi
  else
    ln -sf ${GNAT_RTS}/lib${f}.so ${CUR}/lib${f}.so
  fi
done
popd
#
# Now we create a script that can be used as linker executable
cat > xgcclink <<EOF
#!/bin/sh
GNAT_ROOT= ${ADACC} \$*
EOF
chmod 0755 xgcclink
XGCCLINK=${BD}/xgcclink ; export XGCCLINK
#
# Wrapper for gnatbind
cat > xgnatbind <<EOF
#!/bin/sh
GNAT_ROOT= ${BD}/gnatbind -norpath \$*
EOF
chmod 0755 xgnatbind
XGNATBIND=${BD}/xgnatbind ; export XGNATBIND
#
# Wrapper for gnatlink
cat > xgnatlink <<EOF
#!/bin/sh
GNAT_ROOT= ${BD}/gnatlink --GCC="${XGCCLINK}" --LINK="${XGCCLINK}" \$*
EOF
chmod 0755 xgnatlink
XGNATLINK=${BD}/xgnatlink ; export XGNATLINK
#
# Wrapper for gnatmake
cat > xgnatmake <<EOF
#!/bin/sh
GNAT_ROOT= ${BD}/gnatmake -v -I. -I${GNAT_RTS} --GCC="${CC}" --GNATLINK="${XGNATLINK}" --GNATBIND="${XGNATBIND}" \$*
EOF
chmod 0755 xgnatmake
XGNATMAKE=${BD}/xgnatmake ; export XGNATMAKE
#
# Wrapper for gnatchop
cat > xgnatchop <<EOF
#!/bin/sh
GNAT_ROOT= \
PATH="${BD}:${PATH}" \
ADA_INCLUDE_PATH="${GNAT_RTS}" \
ADA_OBJECTS_PATH="${GNAT_RTS}" \
${BD}/gnatchop  \$*
EOF
chmod 0755 xgnatchop
XGNATCHOP=${BD}/xgnatchop ; export XGNATCHOP
#
# Wrapper for gnatprep
cat > xgnatprep <<EOF
#!/bin/sh
GNAT_ROOT= \
PATH="${BD}:${PATH}" \
${BD}/gnatprep  \$*
EOF
chmod 0755 xgnatprep
XGNATPREP=${BD}/xgnatprep ; export XGNATPREP
#
# Wrapper for gnatls
cat > xgnatls <<EOF
#!/bin/sh
GNAT_ROOT= \
PATH="${BD}:${PATH}" \
${BD}/gnatls  \$*
EOF
chmod 0755 xgnatls
XGNATLS=${BD}/xgnatls ; export XGNATLS
#
# We now do a funny thing. We recompile the gnat tools using gnatmake
# in the source directory against the just compiled new runtime.
# This will make them use the shared runtime and make them much
# smaller.
rm -f ${GNAT_RTS}/*.o
cd ../ada
cp -pdf ${BD}/ada/sdefault.adb .
for f in gnatlink gnatbind gnatchop gnatkr gnatls gnatmem gnatprep \
         gnatpsta gnatpsys gnatxref gnatfind gnatmake gnatcmd
do       
  case "$f" in
     gnatlink|gnatbind)
		la="${BD}/ada/a-link.o"
	        ;;
     gnatpsta)
	        la="${BD}/ada/a-gettty.o ${BD}/ada/a-deftar.o"
	        ;;
     *)         la=
                ;;
  esac
  ${XGNATMAKE} $f \
	-cargs %{RPM_C_FLAGS} %{RPM_ADA_FLAGS} \
	-largs -s ${la}
  cp -pdf $f ${BD}/$f
done
cd ..
#
cd alt-roots
ALT_ROOTS=`pwd`; export ALT_ROOTS
for f in *.ads
do
  ${ADACC} -c %{RPM_C_FLAGS} %{RPM_ADA_FLAGS} $f
done
cd ..
#
# Now we build GLADE, the GNU Ada distributed environment system.
# We build it as a shared library version and merge it with the
# GNAT runtime system. The GLADE makefiles have been patched
# accordingly.
# The GLADE makefile will patch the libgnat*.a in the rts directory
# of the GNAT RTS build. It will also produce libgarlic.a and
# libgarlic_so.a in $RPM_BUILD_ROOT%{ADA_BASE}/%{GLADE_SRC}
#
cd %{GLADE_SRC}
# Copy files from compiler sources because we've patched that
# to include some of the directories from %{ADA_BASE}
for f in ada/*.ad?
do
  a=`basename $f`
  if [ -f ../ada/$a ]
  then
    cp -pdf ../ada/$a $f
  fi
done
# Copy the generated sdefault.adb from the compiler build.
# This ensures compatibility with the GNAT build. 
if [ -f ../obj-%{TARGET_ARCH}-${OS}/ada/sdefault.adb ]
then
    cp -pdf ../obj-%{TARGET_ARCH}-${OS}/ada/sdefault.adb ada/sdefault.adb
fi
#
# We want control over GNATFLAGS
for f in Dist/Makefile.am
do
  cp -f $f $f.tmp
  rm -f $f
  cat $f.tmp |\
    sed "s#@GNATFLAGS@#%{RPM_C_FLAGS} %{RPM_ADA_FLAGS}#g" |\
    sed "s#@ADARTS@#${GNAT_RTS}#g" > $f
done
# In Garlic we need PIC and perhaps debug for shared library support
for f in Garlic/Makefile.am
do
  cp -f $f $f.tmp
  rm -f $f
  cat $f.tmp |\
    sed "s#@GNATFLAGS@#%{RPM_C_FLAGS} %{RPM_ADA_FLAGS} -I-#g" |\
    sed "s#@ADARTS@#${GNAT_RTS}#g" > $f
done
automake
autoconf
#
ADA="${ADACC}" \
CC="${CC}" \
GNATMAKE="${XGNATMAKE}" \
GNATBIND="${XGNATBIND}" \
GNATLINK="${XGNATLINK}" \
GNATLS="${XGNATLS}" \
GARLIC="%{GLADE_DIR}" \
CFLAGS="%{RPM_C_FLAGS}" \
./configure --prefix=%{ADA_BASE} \
            --host=%{TARGET_ARCH}-Ada-${OS}   \
	    --target=%{TARGET_ARCH}-Ada-${OS} \
	    --build=%{TARGET_ARCH}-Ada-${OS}
#
GARLIC="%{GLADE_DIR}" \
make	CC="$CC" \
	GNATMAKE="${XGNATMAKE}" \
	CFLAGS="%{RPM_C_FLAGS}" \
	GMFLAGS="%{RPM_ADA_FLAGS} -gnatg \
		--GCC=\"${CC}\" \
		--GNATBIND=\"${XGNATBIND}\" \
	        --GNATLINK=\"${XGNATLINK}\"" \
	all
cd ..
#
# Now we build ASIS for GNAT. We build the shared library version
# and store objects and packages in separate directories under %{ADA_BASE}
# Friendly enough they have a clean build for static and shared libraries.
cd %{ASIS_SRC}
# Copy files from compiler sources because we've patched that
# to include some of the directories from %{ADA_BASE}
for f in gnat/*.ad?
do
  a=`basename $f`
  if [ -f ../ada/$a ]
  then
    cp -pdf ../ada/$a $f
  fi
done
make	CC="${ADACC}" \
	GNATMAKE="${XGNATMAKE}" \
	CFLAGS="%{RPM_C_FLAGS}" \
	ADAFLAGS="%{RPM_ADA_FLAGS}" \
	GMFLAGS="-aI${GNAT_RTS} -aI${ALT_ROOTS} -aO${GNAT_RTS} -aO${ALT_ROOTS} \
		 %{RPM_ADA_FLAGS} \
	         --GCC=\"${ADACC}\" --GNATBIND=\"${XGNATBIND}\" \
	         --GNATLINK=\"${XGNATLINK}\"" \
	IDIR=$RPM_BUILD_ROOT%{ASIS_DIR} \
	ODIR=$RPM_BUILD_ROOT%{ASIS_DIR} \
	LDIR=$RPM_BUILD_ROOT%{ASIS_DIR} \
	SO_MAJOR=%{GNAT_SO_MAJOR} SO_MINOR=%{GNAT_SO_MINOR} \
	SO_BASE=%{ASIS_SO} \
	all
cd ..
#
# Now we build florist
cd %{FLORIST_SRC}
cat > xgnatmakef <<EOF
#!/bin/sh
${XGNATMAKE} -a \$*
EOF
chmod 0755 xgnatmakef
FGM="`pwd`/xgnatmakef"
GNATMAKE="${FGM}" CC="${CC}" ./configure
make SO_MAJOR=%{GNAT_SO_MAJOR} SO_BASE="%{FLORIST_SO}" GNATMAKE="${FGM}" CC="${ADACC}"
rm -f *.ali *.o
make SO_MAJOR=%{GNAT_SO_MAJOR} SO_BASE="%{FLORIST_SO}" GNATMAKE="${FGM} -a" CC="${ADACC}" shared
rm xgnatmakef
cd ..
#
# Build getopt
#
if [ ! -d getopt_pkg ]
then
  mkdir getopt_pkg
fi
cd getopt_pkg
${XGNATCHOP} $RPM_SOURCE_DIR/getopt_pkg.adb
${ADACC} %{RPM_C_FLAGS} %{RPM_ADA_FLAGS} -c getopt.adb
cd ..
#
# Finally we format the documentation into various output formats
#
cd %{GDOC_SRC}
makeinfo --no-split arm95.texi
gzip -9 arm95.info
#
for f in gnat_rm gnat_ug
do
  texi2dvi ${f}.texi
  dvips -q -V -f < ${f}.dvi > ${f}.ps
  texi2html ${f}.texi
  makeinfo --force --no-split ${f}.texi
  gzip -9 ${f}.info
  makeinfo --force --no-split --no-headers ${f}.texi > ${f}.txt
done
cd ..
#
cd adamode-%{ADAMODE_VERS}
for f in ada-mode
do
  texi2dvi ${f}.texi
  dvips -q -V -f < ${f}.dvi > ${f}.ps
  texi2html ${f}.texi
  makeinfo --force --no-split ${f}.texi
  gzip -9 ${f}.info
  makeinfo --force --no-split --no-headers ${f}.texi > ${f}.txt
done
cd ..
#
pushd %{ALT_BUILD_HTML}
mkdir arm95
cd arm95
unzip $RPM_SOURCE_DIR/rm95html.zip
cd ..
tar xvzf $RPM_SOURCE_DIR/rat95html-1.07.tar.gz
tar xvzf $RPM_SOURCE_DIR/ada95qas.tar.gz
popd
#
cp -pdf $RPM_SOURCE_DIR/index.html.in %{ALT_BUILD_HTML}
cp -pdf $RPM_SOURCE_DIR/adasmall.gif %{ALT_BUILD_HTML}
chmod 0644 %{ALT_BUILD_HTML}/index.html.in \
   %{ALT_BUILD_HTML}/adasmall.gif
#
cp -pdf $RPM_SOURCE_DIR/althtml $RPM_BUILD_ROOT%{ETC_DIR}/althtml
chmod 0755 $RPM_BUILD_ROOT%{ETC_DIR}/althtml
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
# First we copy gdb as gnatgdb. We don't do a full install of it, we just
# want this single executable (this will be stripped later in the script).
cp -pdf gdb-%{GDB_VERSION}/gdb/gdb $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatgdb
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatgdb
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatgdb
#
# Next we copy the adamode files to the adamode directory
cd adamode-%{ADAMODE_VERS}
cp -pdf *.el *.elc $RPM_BUILD_ROOT%{ADAMODE_DIR}
chmod 0444 $RPM_BUILD_ROOT%{ADAMODE_DIR}/*.el*
cd ..

# Copy the ASIS sample application README's into the doc directory.
cp %{ASIS_SRC}/*/gnatelim/README %{GNAT_BUILD_DOC}/README.gnatelim
cp %{ASIS_SRC}/*/gnatstub/README %{GNAT_BUILD_DOC}/README.gnatstub
#
# Copy the ASIS tools binaries to the global binary location
for f in gnatelim gnatstub asistant
do
  bf=`find %{ASIS_SRC} -type f -perm +0111 -name "${f}"`
  if [ "${bf}" != "" ]; then
    cp -pdf ${bf} $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/${f}
    strip $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/${f}
  else
    echo "Binary ${f} not found. Installing a stub."
    cat > $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/${f} <<EOF
#!/bin/sh
echo "$f has not been built." >&2
exit 1
EOF
    chmod +x $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/${f}
  fi  
done
#
#
# Install the C and Ada compiler as well as the Ada runtime directory.
#
cd obj-%{TARGET_ARCH}-${OS}
PATH=$PATH:/sbin:/usr/sbin
make prefix=$RPM_BUILD_ROOT%{CFG_PREFIX} MAKEINFO="makeinfo --no-split" \
	LIBGCC=libgnatgcc.a \
	INSTALL_LIBGCC=install-alt-libgcc \
	LANGUAGES=%{BUILD_LANGUAGES} install
#
FULLVER=`$RPM_BUILD_ROOT%{CFG_PREFIX}/bin/%{TARGET_ARCH}-*${OS}*-gcc --version | cut -d' ' -f1`
FULLPATH=$(dirname $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-*/${FULLVER}/cc1)
#
# Remove some things we don't want to install
#
rm -rf $RPM_BUILD_ROOT%{CFG_PREFIX}/info
rm -f $RPM_BUILD_ROOT/usr/bin/%{TARGET_ARCH}-*${OS}*-gcc
#
# Rename gcc into gnatgcc
if [ "%{GNAT_GCC}" != "gcc" ]; then
  mv -f $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gcc $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/%{GNAT_GCC}
  strip $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/%{GNAT_GCC}
fi
#
strip $FULLPATH/{cc1,cpp,gnat1}
if [ -x $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatbl ]; then
  strip $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatbl
fi
chmod 0755 `find $RPM_BUILD_ROOT%{CFG_PREFIX}/bin -type f`
#
BD="`pwd`" ; export BD
GNAT_RTS="${BD}/ada/rts" ; export GNAT_RTS
GNAT_RTS_SAVE="${BD}/ada/rts-save" ; export GNAT_RTS_SAVE
ADA_INCLUDE_PATH="${GNAT_RTS}"; export ADA_INCLUDE_PATH
ADA_OBJECTS_PATH="${GNAT_RTS}"; export ADA_OBJECTS_PATH
PATH="${BD}:${PATH}"; export PATH
CC="${BD}/xgcc -pipe -B${BD}/" ; export CC
ADACC="${CC} -I. -I${GNAT_RTS}"; export ADACC
LD_LIBRARY_PATH="${GNAT_RTS}:${LD_LIBRARY_PATH}" ; export LD_LIBRARY_PATH
XGCCLINK=${BD}/xgcclink   ; export XGCCLINK
XGNATBIND=${BD}/xgnatbind ; export XGNATBIND
XGNATLINK=${BD}/xgnatlink ; export XGNATLINK
XGNATMAKE=${BD}/xgnatmake ; export XGNATMAKE
XGNATCHOP=${BD}/xgnatchop ; export XGNATCHOP
XGNATPREP=${BD}/xgnatprep ; export XGNATPREP
XGNATLS=${BD}/xgnatls     ; export XGNATLS
cd ..
#
# Install gnathtml, it's a very nice new tool :-)
cp -pdf ada/gnathtml.pl $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnathtml
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnathtml
#
# Move the GNAT shared runtime library under its official name into %{CFG_PREFIX}/lib
mv $FULLPATH/%{ALIB_NAME}/libgnat.so \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GNAT_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GNAT_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
mv $FULLPATH/%{ALIB_NAME}/libgnarl.so \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GNARL_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GNARL_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
#
# Make links to the GNAT shared runtime library at the right places.
ln -sf ../../../../lib%{GNAT_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $FULLPATH/%{ALIB_NAME}/libgnat.so 
ln -sf lib%{GNAT_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GNAT_SO}.so.%{GNAT_SO_MAJOR}
ln -sf lib%{GNARL_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GNARL_SO}.so.%{GNAT_SO_MAJOR}
ln -sf ../../../../lib%{GNARL_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $FULLPATH/%{ALIB_NAME}/libgnarl.so 
#
# Ensure the right permissions
chmod 0444 ${FULLPATH}/%{ALIB_NAME}/*.ali
chmod 0444 ${FULLPATH}/%{AINC_NAME}/*.ad[bs]
#
pushd ${FULLPATH}/adainclude
$RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnathtml -I../adalib \
  -o${RPM_BUILD_ROOT}%{ADA_HTML}/gnat *.ad[bs]
popd
#
# Copy our special script to handle symbolic traces
cp -pdf $RPM_SOURCE_DIR/gnat_addr2line $RPM_BUILD_ROOT%{CFG_PREFIX}/bin
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnat_addr2line
#
# Now we install the GLADE files. They will go to 
# $RPM_BUILD_ROOT%{ADA_BASE}/%{GLADE_SRC}
# But later in this build script we merge the GLADE runtime into the
# GNAT runtime.
cd %{GLADE_SRC}
GARLIC="$RPM_BUILD_ROOT%{GLADE_DIR}" \
GNATMAKE="${XGNATMAKE}" \
make	CC="$CC" \
	GNATMAKE="${XGNATMAKE}" \
	CFLAGS="%{RPM_C_FLAGS}" \
	prefix=$RPM_BUILD_ROOT%{ADA_BASE} \
	GMFLAGS="-aI${GNAT_RTS} \
	         -aO${GNAT_RTS} \
	         --GCC=\"${CC}\" --GNATBIND=\"${XGNATBIND}\" \
	         --GNATLINK=\"${XGNATLINK}\"" \
	install
cd ..
#
# Some runtime objects became dependent on s-stratt because
# we used inlining. s-stratt is modified by GLADE to use
# XDR instead of plain memory dumps for representation of
# the basic types. GLADE has computed during its build
# process a file containing the objects that are modified.
# We build an environment variable with a list of this
# object files for further processing.
REBUILDS="s-stratt.o s-rpc.o s-parint.o"
if [ -f %{GLADE_SRC}/Garlic/inlining ]; then
  if [ "yes" = `cat %{GLADE_SRC}/Garlic/inlining` ]; then
    if [ -f %{GLADE_SRC}/Garlic/gnatlib/rebuild ]; then
      for f in `cat %{GLADE_SRC}/Garlic/gnatlib/rebuild`
      do
        REBUILDS="${REBUILDS} $f"
      done
    else
      echo "Something went wrong during the GLADE build." >&2
      exit 1
    fi
  fi
else
  echo "Something went wrong during the GLADE build." >&2
  exit 1
fi
#
rm -f $RPM_BUILD_ROOT%{GLADE_DIR}/*.o
#
mkdir garlic-lib && cd garlic-lib
ar xv $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}.a \
   `ar t $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}.a`
for f in ${REBUILDS}
do
  ar xv $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GNAT_ALIAS}.a ${f}
done
ar cq lib%{GLADE_ALIAS}.a *.o
cp -pdf lib%{GLADE_ALIAS}.a $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}.a
ranlib $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}.a
chmod 0444 $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}.a
#
rm -f *
#
ar xv $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}_so.a \
   `ar t $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}_so.a`
for f in ${REBUILDS}
do
  ar xv $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GNAT_ALIAS}_so.a ${f}
done
gnatgcc -shared -o lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} -Wl,-soname,lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR} \
	*.o -L${FULLPATH}/%{ALIB_NAME} -lgnat -lgnarl -lz
cp -pdf lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} $RPM_BUILD_ROOT%{CFG_PREFIX}/lib
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
ln -sf lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}
ln -sf ../../lib%{GLADE_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}.so 
cd ..
rm -rf garlic-lib
#
rm -rf $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GNAT_ALIAS}.a  $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GNAT_ALIAS}_so.a  \
       $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GNARL_ALIAS}.a $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GNARL_ALIAS}_so.a \
       $RPM_BUILD_ROOT%{GLADE_DIR}/lib%{GLADE_ALIAS}_so.a
chmod 0444 ${RPM_BUILD_ROOT}%{GLADE_DIR}/*.ad?
chmod 0444 ${RPM_BUILD_ROOT}%{GLADE_DIR}/*.ali
#
cp -pdf $RPM_BUILD_ROOT%{ADA_BASE}/bin/gnatdist $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatdist
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatdist
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnatdist
#
# Now handle ASIS installation
rm -rf gnatlib $RPM_BUILD_ROOT%{ASIS_DIR}/lib%{ASIS_ALIAS}_so.a
# Set Permissions for ASIS files.
chmod 0444 ${RPM_BUILD_ROOT}%{ASIS_DIR}/*.ad?
chmod 0444 ${RPM_BUILD_ROOT}%{ASIS_DIR}/*.ali
#
# Now we patch the makefiles in the example direcories of the ASIS documentation.
# Originally they are integrated in the overall Makefile constructs of the ASIS
# build. They should work standalone of course when installed as samples.
cd %{ASIS_SRC}/examples
for f in */Makefile
do
  cd `dirname $f` && make clean
  rm -f Makefile*
  mv -f make.dist Makefile
  cd ..
done
mv -f make.dist Makefile
cd .. ; cd ..
#
# Move the shared ASIS runtime to the default location and make
# symbolic links at the right places.
mv $RPM_BUILD_ROOT%{ASIS_DIR}/lib%{ASIS_ALIAS}.so \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{ASIS_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
ln -sf lib%{ASIS_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{ASIS_SO}.so.%{GNAT_SO_MAJOR}
ln -sf ../../lib%{ASIS_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $RPM_BUILD_ROOT%{ASIS_DIR}/lib%{ASIS_ALIAS}.so 
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{ASIS_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{ASIS_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
#
pushd ${RPM_BUILD_ROOT}%{ASIS_DIR}
$RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnathtml -I. \
  -o${RPM_BUILD_ROOT}%{ADA_HTML}/asis asis*.ad[bs]
popd
#
cd %{FLORIST_SRC}
#
cp -pdf floristlib/system_* %{FLORIST_BUILD_DOC}/tests
rm -rdf floristlib/system_*
cp -pdf floristlib/*.ad? $RPM_BUILD_ROOT%{AINC_DIR}
cp -pdf floristlib/*.ali $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pdf floristlib/lib%{FLORIST_ALIAS}.a  $RPM_BUILD_ROOT%{ALIB_DIR}/lib%{FLORIST_ALIAS}.a
#
cp -pdf floristlib-shared/lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
ln -sf lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
       $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR}
ln -sf ../../lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR} \
   $RPM_BUILD_ROOT%{ALIB_DIR}/lib%{FLORIST_ALIAS}.so
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
chmod 0755 $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{FLORIST_SO}.so.%{GNAT_SO_MAJOR}.%{GNAT_SO_MINOR}
#
rm -f tests/*.florist
cp -pdf README   %{FLORIST_BUILD_DOC}
cp -pdf COPYING	 %{FLORIST_BUILD_DOC}
cp -pdrf tests   %{FLORIST_BUILD_DOC}
cp -pdf gnatprep.config %{FLORIST_BUILD_DOC}/tests
#
chmod 0755 %{FLORIST_BUILD_DOC}/tests/run_tests_?
#
cd ..
#
pushd ${RPM_BUILD_ROOT}%{AINC_DIR}
$RPM_BUILD_ROOT%{CFG_PREFIX}/bin/gnathtml -I../%{ALIB_NAME} \
  -o${RPM_BUILD_ROOT}%{ADA_HTML}/florist posix*.ad[bs]
popd
#
cd alt-roots
for f in *.ads
do
  g=`basename $f .ads`
  cp -pdf ${f}     $RPM_BUILD_ROOT%{AINC_DIR}
  cp -pdf ${g}.ali $RPM_BUILD_ROOT%{ALIB_DIR}
  cp -pdf ${g}.o   $RPM_BUILD_ROOT%{ALIB_DIR}
  chmod 0444 $RPM_BUILD_ROOT%{ALIB_DIR}/${g}.ali
  chmod 0444 $RPM_BUILD_ROOT%{ALIB_DIR}/${g}.o
  chmod 0444 $RPM_BUILD_ROOT%{AINC_DIR}/${f}
done
cd ..
#
cd getopt_pkg
cp -pdf getopt.ad? $RPM_BUILD_ROOT%{AINC_DIR}
cp -pdf getopt.ali $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pdf getopt.o   $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pdf test*      %{GNAT_BUILD_DOC}/getopt/
cat > %{GNAT_BUILD_DOC}/getopt/Makefile <<EOF
all:
	gnatmake -v test_getopt -cargs -O

clean:
	rm -f test_getopt *.o *.ali test_getopt core
EOF
chmod 0444 $RPM_BUILD_ROOT%{ALIB_DIR}/getopt.*
chmod 0444 $RPM_BUILD_ROOT%{AINC_DIR}/getopt.*
cd ..
#
# Make some links to be able to provide compatibility with earlier releases 
# of this package
ln -s ada/%{GLADE_NAME} ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib/%{GLADE_ALIAS}
ln -s ada/%{ASIS_NAME}  ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib/asis
#
# Copy all the documentation and samples to the doc directory
#
cd adamode-%{ADAMODE_VERS}
cp -pdf ada-mode.info.gz $RPM_BUILD_ROOT%{INFO_DIR}/
cp -pdf ChangeLog        %{GNAT_BUILD_DOC}/adamode/
cp -pdf README           %{GNAT_BUILD_DOC}/adamode/
cp -pdf ada-mode.texi    %{GNAT_BUILD_DOC}/adamode/
cp -pdf ada-mode.ps      %{GNAT_BUILD_DOC}/adamode/
cp -pdf ada-mode.txt     %{GNAT_BUILD_DOC}/adamode/
cp -pdf ada-mode.html    %{ALT_BUILD_HTML}
cd ..
#
cp -pd  gdb-%{GDB_VERSION}.gnat.%{GNAT_VERSION}-docs/*.htm* %{ALT_BUILD_HTML}
rm -f   gdb-%{GDB_VERSION}.gnat.%{GNAT_VERSION}-docs/*.htm*
cp -pd  gdb-%{GDB_VERSION}.gnat.%{GNAT_VERSION}-docs/* %{GDB_BUILD_DOC}
#
cp -pd  %{GDOC_SRC}/gnat_*.html    %{ALT_BUILD_HTML}
cp -pd  %{GDOC_SRC}/gnat_*.ps      %{GNAT_BUILD_DOC}
cp -pd  %{GDOC_SRC}/gnat_*.txt     %{GNAT_BUILD_DOC}
cp -pd  %{GDOC_SRC}/gnat_*.info.gz $RPM_BUILD_ROOT%{INFO_DIR}
cp -pd  %{GDOC_SRC}/arm95.info.gz  $RPM_BUILD_ROOT%{INFO_DIR}
cp -pd  %{GDOC_SRC}/*.texi         %{GNAT_BUILD_DOC}
cp -pd  %{GDOC_SRC}/texinfo.tex    %{GNAT_BUILD_DOC}
cp -pd  %{GNAT_SRC}/COPYING        %{GNAT_BUILD_DOC}
cp -pd  %{GNAT_SRC}/features       %{GNAT_BUILD_DOC}
cp -pd  %{GNAT_SRC}/gnatinfo.txt   %{GNAT_BUILD_DOC}
cp -pdr %{GNAT_SRC}/examples       %{GNAT_BUILD_DOC}
#
rm -f `find %{GLADE_SRC}/Examples -name 'Makefile.*' -o -name '*.in' -o -name '*.glade'`
cp -pd  %{GLADE_SRC}/README             %{GLADE_BUILD_DOC}
cp -pd  %{GLADE_SRC}/README.ALT         %{GLADE_BUILD_DOC}
cp -pd  %{GLADE_SRC}/COPYING            %{GLADE_BUILD_DOC}
cp -pd  %{GLADE_SRC}/NEWS               %{GLADE_BUILD_DOC}
cp -pd  %{GLADE_SRC}/Doc/*              %{GLADE_BUILD_DOC}
cp -prd %{GLADE_SRC}/Examples/          %{GLADE_BUILD_DOC}
cp -pd  %{GLADE_SRC}/Garlic/rfc1832.txt %{GLADE_BUILD_DOC}
#
rm -f `find %{ASIS_SRC}/examples -name '*.asis'`
cp -pd  %{ASIS_SRC}/README                     %{ASIS_BUILD_DOC}
cp -pd  %{ASIS_SRC}/documentation/asisinfo.txt %{ASIS_BUILD_DOC}
cp -pd  %{ASIS_SRC}/documentation/asis_rm.txt  %{ASIS_BUILD_DOC}
cp -pd  %{ASIS_SRC}/documentation/asis_ug.txt  %{ASIS_BUILD_DOC}
cp -pd  %{ASIS_SRC}/documentation/features.txt %{ASIS_BUILD_DOC}
cp -pdr %{ASIS_SRC}/examples                   %{ASIS_BUILD_DOC}
#
cp -pd  ${RPM_SOURCE_DIR}/README.Linux.glibc-%{GLIBC_VERSION}.html %{GNAT_BUILD_DOC}/README.Linux.html
cp -pd  ${RPM_SOURCE_DIR}/README.ALT.emacs %{GNAT_BUILD_DOC}/
cp -pd  ${RPM_SOURCE_DIR}/%{BASE_NAME}-FHS-Proposal %{GNAT_BUILD_DOC}
#
lnx=`type -p lynx`
if [ "$lnx" -ne "" ]; then
  if [ -x $lnx ]; then
    $lnx -dump -nolist %{GNAT_BUILD_DOC}/README.Linux.html > %{GNAT_BUILD_DOC}/README.Linux
  fi
fi
cp -pd  ${RPM_SOURCE_DIR}/gnat.1 $RPM_BUILD_ROOT%{CFG_PREFIX}/man/man1/gnat.1
#
# Ensure all the document files have correct permissions
find %{GNAT_BUILD_DOC} -type f -exec chmod 0644 {} \;
find %{GNAT_BUILD_DOC} -type d -exec chmod 0755 {} \;
find %{ALT_BUILD_HTML} -type f -exec chmod 0644 {} \;
find %{ALT_BUILD_HTML} -type d -exec chmod 0755 {} \;
find $RPM_BUILD_ROOT%{CFG_PREFIX}/man -type f -exec chmod 0644 {} \;
find $RPM_BUILD_ROOT%{CFG_PREFIX}/man -type d -exec chmod 0755 {} \;
#
# Now we generate the profile scripts from the templates.
# They still contain the variable @INSTALL_PREFIX@ which
# will be replaced at install time.
# 
for f in %{BASE_NAME}.sh.in %{BASE_NAME}.csh.in \
	 %{BASE_NAME}-rts.sh.in %{BASE_NAME}-rts.csh.in
do
  g=`basename ${f} .in` 
  sed "s:@CFG_PREFIX@:%{CFG_PREFIX}:g"     < ${RPM_SOURCE_DIR}/${f} |\
  sed "s:@ADA_ROOT@:%{ADA_ROOT}:g"         |\
  sed "s:@ASIS_NAME@:%{ASIS_NAME}:g"       |\
  sed "s:@GLADE_NAME@:%{GLADE_NAME}:g"     |\
  sed "s:@VERS@:%{GNAT_VERSION}:g"         |\
  sed "s:@AUTHOR_NAME@:%{AUTHOR_NAME}:g"   |\
  sed "s:@EMACS_DIR@:%{EMACS_DIR}:g"       |\
  sed "s:@INFO_DIR@:%{INFO_NAME}:g"        |\
  sed "s:@AUTHOR_MAIL@:%{AUTHOR_MAIL}:g"   > ${RPM_BUILD_ROOT}%{ETC_DIR}/${g}
  chmod 0755 ${RPM_BUILD_ROOT}%{ETC_DIR}/${g}
done         
#
#  ---------------------------------------------------------------------------
%pre
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
# We can do some heuristics to verify that the runtime has been installed
# with the same prefix.
if [ ! -f "${GNAT_INSTALL_PREFIX}/lib/lib%{GNAT_SO}.so.%{GNAT_SO_MAJOR}" ]
then
  if [ -f ${etc_prof}/%{BASE_NAME}-rts.sh ]; then
#   if it has been installed but with a different prefix, then we fail
#   if it hasn't been installed at all, rpm will fail by default
    echo "The runtime package %{BASE_NAME} has been installed with another" 2>&1
    echo "--prefix value. Please use the same value for this package."     2>&1
    exit 1
  fi
fi
#  ---------------------------------------------------------------------------
%post
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
htmldir=${GNAT_INSTALL_PREFIX}/share/ada/html
pkgfile=${htmldir}/packages

html_insert() {
  mkdir -p ${htmldir} 2>/dev/null
  if [ -f $pkgfile ]; then
    awk -F, '{printf "%s,\n",$1;}' < $pkgfile | grep -q "$1,"
    if [ $? -eq 0 ]; then
       sed -e "/^$1,/d" < $pkgfile >${pkgfile}.tmp
       mv -f ${pkgfile}.tmp ${pkgfile}
    fi
  fi
  echo "$1,$2,$3" >> $pkgfile
}

html_remove() {
   sed -e "/^$1,/d" < ${pkgfile} > ${pkgfile}.tmp
   mv -f ${pkgfile}.tmp ${pkgfile}
}

html_generate() {
  insmarker="<!--PACKAGES-->"
  indexfile=${htmldir}/index.html
  touch ${pkgfile}.in
  if [ -f ${pkgfile} ]; then
    awk -F, '{printf "<li><a href=\"%s\" TARGET=\"%s\">%s</a></li>\n",$2,$1,$3;}' < ${pkgfile} > ${pkgfile}.in
  fi
  if [ -f ${indexfile}.in ]; then
    cat > ${pkgfile}.sed <<EOF
/^${insmarker}/r ${pkgfile}.in
/^${insmarker}/d
EOF
    sed -f ${pkgfile}.sed < ${indexfile}.in > ${indexfile}
    rm -f ${pkgfile}.sed
  fi
  rm -f ${pkgfile}.in
}
mkdir -p ${etc_prof} > /dev/null 2>&1
#
for f in %{BASE_NAME}.sh %{BASE_NAME}.csh
do
  if [ ! -f ${ETC_DIR}/${f} ]; then
    echo "%{BASE_NAME} installation is inconsistent." >&2
    exit 1
  else
    cp -pdf ${ETC_DIR}/${f} ${ETC_DIR}/${f}.in
    sed "s:@INSTALL_PREFIX@:${GNAT_INSTALL_PREFIX}:g" \
      < ${ETC_DIR}/${f}.in > ${ETC_DIR}/${f}
    rm -f ${ETC_DIR}/${f}.in
    chmod 0755 ${ETC_DIR}/${f}
    if [ ${UID} -eq 0 ]; then 
      chown %{DEF_USER}.%{DEF_GROUP} ${ETC_DIR}/${f}
      ln -sf ${ETC_DIR}/${f} ${etc_prof}/${f}
    else
      appended=0	
      case "$f" in
	*.sh)  if [ ! -f ${HOME}/.profile -o -w ${HOME}/.profile ]; then 
	          echo "# Inserted automatically by GNAT install" >> ${HOME}/.profile
	          echo "source ${ETC_DIR}/${f}" >> ${HOME}/.profile
	          appended=1
               fi 
	       ;;
	*.csh) if [ ! -f ${HOME}/.login -o -w ${HOME}/.login ]; then
	          echo "# Inserted automatically by GNAT install" >> ${HOME}/.login
                  echo "source ${ETC_DIR}/${f}" >> ${HOME}/.login
                  appended=1
               fi
	       ;;
	*)     ;;
      esac
      if [ $appended -eq 0 ]; then
         echo "The install script couldn't modify your .profile and/or .login script." >&2
	 echo "Please check and add manually a line into your login script that does" >&2
         echo "   source ${ETC_DIR}/${f}" >&2
      fi
    fi
  fi
done
#
html_insert   "gnat" "gnat/index.htm" "GNAT Runtime Packages"
html_generate
#  ---------------------------------------------------------------------------
%postun
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
if [ ${UID} -eq 0 ]; then
  rm -f ${etc_prof}/%{BASE_NAME}.sh /etc/profile.d/%{BASE_NAME}.csh
fi
#  ---------------------------------------------------------------------------
%preun
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
htmldir=${GNAT_INSTALL_PREFIX}/share/ada/html
pkgfile=${htmldir}/packages

html_insert() {
  mkdir -p ${htmldir} 2>/dev/null
  if [ -f $pkgfile ]; then
    awk -F, '{printf "%s,\n",$1;}' < $pkgfile | grep -q "$1,"
    if [ $? -eq 0 ]; then
       sed -e "/^$1,/d" < $pkgfile >${pkgfile}.tmp
       mv -f ${pkgfile}.tmp ${pkgfile}
    fi
  fi
  echo "$1,$2,$3" >> $pkgfile
}

html_remove() {
   sed -e "/^$1,/d" < ${pkgfile} > ${pkgfile}.tmp
   mv -f ${pkgfile}.tmp ${pkgfile}
}

html_generate() {
  insmarker="<!--PACKAGES-->"
  indexfile=${htmldir}/index.html
  touch ${pkgfile}.in
  if [ -f ${pkgfile} ]; then
    awk -F, '{printf "<li><a href=\"%s\" TARGET=\"%s\">%s</a></li>\n",$2,$1,$3;}' < ${pkgfile} > ${pkgfile}.in
  fi
  if [ -f ${indexfile}.in ]; then
    cat > ${pkgfile}.sed <<EOF
/^${insmarker}/r ${pkgfile}.in
/^${insmarker}/d
EOF
    sed -f ${pkgfile}.sed < ${indexfile}.in > ${indexfile}
    rm -f ${pkgfile}.sed
  fi
  rm -f ${pkgfile}.in
}

html_remove   gnat
html_generate

if [ $1 -eq 0 ]; then
  rm -f ${GNAT_INSTALL_PREFIX}%{HTML_BASE}/index.html \
    ${GNAT_INSTALL_PREFIX}%{HTML_BASE}/packages
fi
#  ---------------------------------------------------------------------------
%post -n %{GNATRT_PKG_NAME}
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
mkdir -p ${etc_prof} > /dev/null 2>&1
#
for f in %{BASE_NAME}-rts.sh %{BASE_NAME}-rts.csh
do
  if [ ! -f ${ETC_DIR}/${f} ]; then
       echo "%{BASE_NAME} installation is inconsistent." >&2
       exit 1
  else
    cp -pdf ${ETC_DIR}/${f} ${ETC_DIR}/${f}.in
    sed "s:@INSTALL_PREFIX@:${GNAT_INSTALL_PREFIX}:g" \
      < ${ETC_DIR}/${f}.in > ${ETC_DIR}/${f}
    rm -f ${ETC_DIR}/${f}.in
    chmod 0755 ${ETC_DIR}/${f}
    if [ ${UID} -eq 0 ]; then
       chown %{DEF_USER}.%{DEF_GROUP} ${ETC_DIR}/${f}
       ln -sf ${ETC_DIR}/${f} ${etc_prof}/${f}
    else # User level install
       appended=0	
       case "$f" in
	 *.sh)  if [ ! -f ${HOME}/.profile -o -w ${HOME}/.profile ]; then 
	           echo "# Inserted automatically by GNAT install" >> ${HOME}/.profile
	           echo "source ${ETC_DIR}/${f}" >> ${HOME}/.profile
	           appended=1
                fi 
	        ;;
	 *.csh) if [ ! -f ${HOME}/.login -o -w ${HOME}/.login ]; then
	           echo "# Inserted automatically by GNAT install" >> ${HOME}/.login
                   echo "source ${ETC_DIR}/${f}" >> ${HOME}/.login
                   appended=1
                fi
		;;
	 *)     ;;
       esac
       if [ $appended -eq 0 ]; then
          echo "The install script couldn't modify your .profile and/or .login script." >&2
	  echo "Please check and add manually a line into your login script that does" >&2
          echo "   source ${ETC_DIR}/${f}" >&2
       fi
    fi
  fi
done
#
# The next step is done to ensure that also programs that run from
# non-logon environments (e.g. started by inetd) can find the
# shared libraries
#
if [ ${UID} -eq 0 ]; then
   for f in /etc/ld.so.conf /etc/ld.so.conf.in
   do
      if [ -f ${f} ]; then
         grep -q -s "^${GNAT_INSTALL_PREFIX}/lib\$" ${f}
         if [ $? -ne 0 ]; then
	    cat >> ${f} << EOF
${GNAT_INSTALL_PREFIX}/lib
EOF
         fi
      fi
   done
  /sbin/ldconfig
fi
#
#  ---------------------------------------------------------------------------
%postun -n %{GNATRT_PKG_NAME}
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
if [ ${UID} -eq 0 ]; then
  rm -f ${etc_prof}/%{BASE_NAME}-rts.sh ${etc_prof}/%{BASE_NAME}-rts.csh 
  # Only if the lib directory vanished we will remove it from /etc/ld.so.conf
  # It is nearly impossible for us to detect, whether or not we are allowed
  # to remove the entry if the directory was not removed because there are
  # still data in it. Leaving it doesn't harm and if runtime is installed
  # again with the same prefix it will be reused.
  if [ ! -d ${GNAT_INSTALL_PREFIX}/lib ]; then
    tconf=/tmp/ld.so.conf.tmp
    cp -f /etc/ld.so.conf ${tconf}
    if [ -f ${tconf} ]; then
      sed "s#^${GNAT_INSTALL_PREFIX}/lib\$##g" < ${tconf} |\
      sed "/^\$/d"  > /etc/ld.so.conf
      rm -f ${tconf}
    fi
  fi
  /sbin/ldconfig
else
  GNAT_found=1
  grep -q -s "Inserted automatically by GNAT install" ${HOME}/.profile
  if [ $? -ne 0 ]; then
    grep -q -s "Inserted automatically by GNAT install" ${HOME}/.login
    if [ $? -ne 0 ]; then
	GNAT_found=0
    fi 
  fi
  if [ $GNAT_found -ne 0 ]; then
    echo "Please don't forget to edit the .profile and/or .login in your" >&2
    echo "home directory and to remove the inclusion of the GNAT init files." >&2
  fi
fi
#  ---------------------------------------------------------------------------
%pre -n gnat-glade
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${GNAT_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${GNAT_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%pre -n florist
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${GNAT_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${GNAT_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post -n florist
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
htmldir=${GNAT_INSTALL_PREFIX}/share/ada/html
pkgfile=${htmldir}/packages

html_insert() {
  mkdir -p ${htmldir} 2>/dev/null
  if [ -f $pkgfile ]; then
    awk -F, '{printf "%s,\n",$1;}' < $pkgfile | grep -q "$1,"
    if [ $? -eq 0 ]; then
       sed -e "/^$1,/d" < $pkgfile >${pkgfile}.tmp
       mv -f ${pkgfile}.tmp ${pkgfile}
    fi
  fi
  echo "$1,$2,$3" >> $pkgfile
}

html_remove() {
   sed -e "/^$1,/d" < ${pkgfile} > ${pkgfile}.tmp
   mv -f ${pkgfile}.tmp ${pkgfile}
}

html_generate() {
  insmarker="<!--PACKAGES-->"
  indexfile=${htmldir}/index.html
  touch ${pkgfile}.in
  if [ -f ${pkgfile} ]; then
    awk -F, '{printf "<li><a href=\"%s\" TARGET=\"%s\">%s</a></li>\n",$2,$1,$3;}' < ${pkgfile} > ${pkgfile}.in
  fi
  if [ -f ${indexfile}.in ]; then
    cat > ${pkgfile}.sed <<EOF
/^${insmarker}/r ${pkgfile}.in
/^${insmarker}/d
EOF
    sed -f ${pkgfile}.sed < ${indexfile}.in > ${indexfile}
    rm -f ${pkgfile}.sed
  fi
  rm -f ${pkgfile}.in
}

html_insert   "florist" "florist/index.htm" "Posix 1003.5 Binding Packages"
html_generate

#  ---------------------------------------------------------------------------
%postun -n florist
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
htmldir=${GNAT_INSTALL_PREFIX}/share/ada/html
pkgfile=${htmldir}/packages

html_insert() {
  mkdir -p ${htmldir} 2>/dev/null
  if [ -f $pkgfile ]; then
    awk -F, '{printf "%s,\n",$1;}' < $pkgfile | grep -q "$1,"
    if [ $? -eq 0 ]; then
       sed -e "/^$1,/d" < $pkgfile >${pkgfile}.tmp
       mv -f ${pkgfile}.tmp ${pkgfile}
    fi
  fi
  echo "$1,$2,$3" >> $pkgfile
}

html_remove() {
   sed -e "/^$1,/d" < ${pkgfile} > ${pkgfile}.tmp
   mv -f ${pkgfile}.tmp ${pkgfile}
}

html_generate() {
  insmarker="<!--PACKAGES-->"
  indexfile=${htmldir}/index.html
  touch ${pkgfile}.in
  if [ -f ${pkgfile} ]; then
    awk -F, '{printf "<li><a href=\"%s\" TARGET=\"%s\">%s</a></li>\n",$2,$1,$3;}' < ${pkgfile} > ${pkgfile}.in
  fi
  if [ -f ${indexfile}.in ]; then
    cat > ${pkgfile}.sed <<EOF
/^${insmarker}/r ${pkgfile}.in
/^${insmarker}/d
EOF
    sed -f ${pkgfile}.sed < ${indexfile}.in > ${indexfile}
    rm -f ${pkgfile}.sed
  fi
  rm -f ${pkgfile}.in
}

html_remove   florist
html_generate
#  ---------------------------------------------------------------------------
%pre -n asis
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${GNAT_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${GNAT_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post -n asis
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
htmldir=${GNAT_INSTALL_PREFIX}/share/ada/html
pkgfile=${htmldir}/packages

html_insert() {
  mkdir -p ${htmldir} 2>/dev/null
  if [ -f $pkgfile ]; then
    awk -F, '{printf "%s,\n",$1;}' < $pkgfile | grep -q "$1,"
    if [ $? -eq 0 ]; then
       sed -e "/^$1,/d" < $pkgfile >${pkgfile}.tmp
       mv -f ${pkgfile}.tmp ${pkgfile}
    fi
  fi
  echo "$1,$2,$3" >> $pkgfile
}

html_remove() {
   sed -e "/^$1,/d" < ${pkgfile} > ${pkgfile}.tmp
   mv -f ${pkgfile}.tmp ${pkgfile}
}

html_generate() {
  insmarker="<!--PACKAGES-->"
  indexfile=${htmldir}/index.html
  touch ${pkgfile}.in
  if [ -f ${pkgfile} ]; then
    awk -F, '{printf "<li><a href=\"%s\" TARGET=\"%s\">%s</a></li>\n",$2,$1,$3;}' < ${pkgfile} > ${pkgfile}.in
  fi
  if [ -f ${indexfile}.in ]; then
    cat > ${pkgfile}.sed <<EOF
/^${insmarker}/r ${pkgfile}.in
/^${insmarker}/d
EOF
    sed -f ${pkgfile}.sed < ${indexfile}.in > ${indexfile}
    rm -f ${pkgfile}.sed
  fi
  rm -f ${pkgfile}.in
}

html_insert   "asis" "asis/index.htm" "Ada Semantic Interface Specification Packages (ASIS)"
html_generate
#  ---------------------------------------------------------------------------
%postun -n asis
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
etc_prof="/etc/profile.d"
ETC_DIR="${GNAT_INSTALL_PREFIX}%{ADA_ROOT}/%{ETC_NAME}"
#
GNAT_INSTALL_PREFIX=${RPM_INSTALL_PREFIX:-/usr}
htmldir=${GNAT_INSTALL_PREFIX}/share/ada/html
pkgfile=${htmldir}/packages

html_insert() {
  mkdir -p ${htmldir} 2>/dev/null
  if [ -f $pkgfile ]; then
    awk -F, '{printf "%s,\n",$1;}' < $pkgfile | grep -q "$1,"
    if [ $? -eq 0 ]; then
       sed -e "/^$1,/d" < $pkgfile >${pkgfile}.tmp
       mv -f ${pkgfile}.tmp ${pkgfile}
    fi
  fi
  echo "$1,$2,$3" >> $pkgfile
}

html_remove() {
   sed -e "/^$1,/d" < ${pkgfile} > ${pkgfile}.tmp
   mv -f ${pkgfile}.tmp ${pkgfile}
}

html_generate() {
  insmarker="<!--PACKAGES-->"
  indexfile=${htmldir}/index.html
  touch ${pkgfile}.in
  if [ -f ${pkgfile} ]; then
    awk -F, '{printf "<li><a href=\"%s\" TARGET=\"%s\">%s</a></li>\n",$2,$1,$3;}' < ${pkgfile} > ${pkgfile}.in
  fi
  if [ -f ${indexfile}.in ]; then
    cat > ${pkgfile}.sed <<EOF
/^${insmarker}/r ${pkgfile}.in
/^${insmarker}/d
EOF
    sed -f ${pkgfile}.sed < ${indexfile}.in > ${indexfile}
    rm -f ${pkgfile}.sed
  fi
  rm -f ${pkgfile}.in
}

html_remove   asis
html_generate
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc %{GNAT_BUILD_DOC}/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/bin
%dir %{CFG_PREFIX}/lib
%dir %{CFG_PREFIX}/share
%dir %{CFG_PREFIX}/lib/gcc-lib
%dir %{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}
%dir %{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}
%dir %{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/include
%dir %{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/adalib
%dir %{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/adainclude
%dir %{CFG_PREFIX}/man
%dir %{CFG_PREFIX}/man/man1
%dir %{ADA_BASE}
%dir %{ETC_DIR}
%dir %{ADAMODE_DIR}
%dir %{INFO_DIR}
%dir %{ALIB_DIR}
%dir %{AINC_DIR}
%dir %{CFG_PREFIX}/doc
%dir %{ADA_SHARE}
%dir %{ADA_HTML}
%dir %{ADA_HTML}/gnat
%dir %{ADA_HTML}/arm95
%dir %{ADA_HTML}/rat95html-1.07
%dir %{ADA_HTML}/ada95qas-1.0
%docdir %{DOC_BASE}
%{CFG_PREFIX}/bin/gnat[a-c]*
%{CFG_PREFIX}/bin/gnat[e-z]*
%{AINC_DIR}/alt*
%{ALIB_DIR}/alt*
%{AINC_DIR}/gnu*
%{AINC_DIR}/getopt*
%{ALIB_DIR}/gnu*
%{ALIB_DIR}/getopt*
%{ETC_DIR}/%{BASE_NAME}.*sh
%{ETC_DIR}/althtml
%{ADAMODE_DIR}/*.el*
%{INFO_DIR}/*
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/include/*
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/adalib/Makefile.adalib
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/adalib/*.ali
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/adalib/*.a
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/adalib/*.so*
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/adainclude/*
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/*.o
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/*.a
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/cc1
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/gnat1
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/cpp
%{CFG_PREFIX}/lib/gcc-lib/%{TARGET_ARCH}-Ada-%{TARGET_OS}/%{GCC_VERSION}/specs
%{CFG_PREFIX}/man/man1/gnat.1*
%{ADA_HTML}/index.html.in
%{ADA_HTML}/*.html
%{ADA_HTML}/*.gif
%{ADA_HTML}/arm95/*
%{ADA_HTML}/rat95html-1.07/*
%{ADA_HTML}/ada95qas-1.0/*
%{ADA_HTML}/gnat/*
#  ---------------------------------------------------------------------------
%files -n %{GNATRT_PKG_NAME}
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%dir %{CFG_PREFIX}/bin
%dir %{ADA_BASE}
%dir %{ETC_DIR}
%{CFG_PREFIX}/bin/gnat_addr2line
%{CFG_PREFIX}/lib/lib%{GNAT_SO}*.so*
%{CFG_PREFIX}/lib/lib%{GNARL_SO}*.so*
%{CFG_PREFIX}/lib/lib%{GLADE_SO}*.so*
%{CFG_PREFIX}/lib/lib%{ASIS_SO}*.so*
%{CFG_PREFIX}/lib/lib%{FLORIST_SO}*.so*
%{ETC_DIR}/%{BASE_NAME}-rts.*sh
#
%files -n gnat-glade
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc %{GLADE_BUILD_DOC}/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/bin
%dir %{CFG_PREFIX}/lib
%dir %{ADA_BASE}
%dir %{GLADE_DIR}
%docdir %{DOC_BASE}
%{CFG_PREFIX}/bin/gnatdist
%{CFG_PREFIX}/lib/%{GLADE_ALIAS}
%{GLADE_DIR}/*
#
%files -n asis
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc %{ASIS_BUILD_DOC}/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/bin
%dir %{CFG_PREFIX}/lib
%dir %{ADA_BASE}
%dir %{ASIS_DIR}
%docdir %{DOC_BASE}
%dir %{ADA_HTML}
%dir %{ADA_HTML}/asis
%{CFG_PREFIX}/bin/asistant
%{CFG_PREFIX}/lib/%{ASIS_ALIAS}
%{ASIS_DIR}/*
%{ADA_HTML}/asis/*
#
%files -n florist
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc %{FLORIST_BUILD_DOC}/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%dir %{ADA_BASE}
%docdir %{DOC_BASE}
%dir %{ADA_HTML}
%dir %{ADA_HTML}/florist
%{AINC_DIR}/posix*
%{ALIB_DIR}/posix*
%{ALIB_DIR}/lib%{FLORIST_ALIAS}*.*
%{ADA_HTML}/florist/*
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#  ---------------------------------------------------------------------------
#
%changelog
* Fri May 05 2000 Lenny Cartier <lenny@mandrakesoft.com> 3.12p-11mdk
- new in contribs

* Thu Apr 27 2000 Juergen Pfeifer <juergen@gnuada.org>
- Published as release 11

* Wed Apr 26 2000 Juergen Pfeifer <juergen@gnuada.org>
- Use computed GNAT_INSTALL_PREFIX instead of RPM_INSTALL_... to support
  SuSE YaST based installations.

* Fri Apr 14 2000 Juergen Pfeifer <juergen@gnuada.org>
- Published as Release 10

* Wed Apr 12 2000 Juergen Pfeifer <juergen@gnuada.org>
- Improve symbolic tracebacks to handle different verions of
  binutils and make it more secure.

* Sat Mar 04 2000 Juergen Pfeifer <juergen@gnuada.org>
- Fixed florist to look also in librt for aio_
- Enhanced spec file to allow also a bootstrap build
  with the previous version of gnat. This will hopefully
  reduce my efforts when 3.13p will be released

* Sun Feb 27 2000 Juergen Pfeifer <juergen@gnuada.org>
- Published as Release 9

* Wed Feb 23 2000 Juergen Pfeifer <juergen@gnuada.org>
- Grand package renaming

* Tue Feb 22 2000 Juergen Pfeifer <juergen@gnuada.org>
- Use -funwind-tables when compiling a-except.adb for libgnat to enable
  correct symbolic tracebacks for exception occurrences.
- Make the generated sdefault.adb in the build process of gnatdist the same
  as the one generated during the build of GNAT.

* Mon Jan 03 2000 Juergen Pfeifer <juergen@gnuada.org>
- Published as Release 8

* Sun Jan 02 2000 Juergen Pfeifer <juergen@gnuada.org>
- Use the new HTML formatted LRM and Rationale

* Fri Dec 31 1999 Juergen Pfeifer <juergen@gnuada.org>
- Enabled symbolic tracebacks

* Wed Dec 29 1999 Juergen Pfeifer <juergen@gnuada.org>
- Do not use "-fomit-frame-pointer" option when compiling
  some of the runtime sources. This caused problems with
  the zero cost exception handling implementation and with
  symbolic tracebacks.
- Inlined HTML generation into the installation scripts to eliminate
  installation order dependencies.

* Tue Dec 07 1999 Juergen Pfeifer <juergen@gnuada.org>
- Fixed althtml script for automatic maintenance of the
  generated Web page index. This was broken for first time
  installs.
- Published as Release 7

* Mon Dec 06 1999 Juergen Pfeifer <juergen@gnuada.org>
- Fixed build script so that it doesn't delete the
  packages and index.html file when updating.

* Fri Dec 03 1999 Juergen Pfeifer <juergen@gnuada.org>
- Fixed gnatgdb. Merged H.J. Lu's 4.17 patches with the
  ACT patches and applied some improvements provided by
  Lucian B. Landry.

* Wed Nov 24 1999 Juergen Pfeifer <juergen@gnuada.org>
- Published as Release 6

* Tue Nov 23 1999 Juergen Pfeifer <juergen@gnuada.org>
- README.Linux is now provided also as HTML. Actually the ASCII version
  is generated from the HTML version using lynx (lynx is required to
  do a complete build).

* Mon Nov 22 1999 Juergen Pfeifer <juergen@gnuada.org>
- Added getopt package

* Fri Nov 19 1999 Juergen Pfeifer <juergen@gnuada.org>
- Added patch from Emmanuel Briot <briot@gnat.com> that prevents emacs
  adamode to untabify makefiles.

* Mon Nov 15 1999 Juergen Pfeifer <juergen@gnuada.org>
- Fix problem that tasking runtime isn't linked automatically
  in some cases when using protected objects.
- Published as Release 5

* Sun Nov 07 1999 Juergen Pfeifer <juergen@gnuada.org>
- Deploy also a modified Makefile.adalib that can build a
  new static and shared runtime.

* Sat Nov 06 1999 Juergen Pfeifer <juergen@gnuada.org>
- Implementing /usr/share/ada/html subtree; adding internal script
  to automate index generation for html documentation homepage.

* Fri Nov 05 1999 Juergen Pfeifer <juergen@gnuada.org>
- Fixed %files descriptions. Especially remove asis subdir
  from gnat-devel package.
- Fixed missing libflorist.so symlink to major version

* Thu Nov 04 1999 Juergen Pfeifer <juergen@gnuada.org>
- Add french translations of summaries. Many thanks to
  Franois Godm for that.
- Removed INFOPATH setting from profile scripts.
- Add new README.ALT.emacs
- Publish as Release 4

* Mon Nov 01 1999 Juergen Pfeifer <juergen@gnuada.org>
- Recompile also gnatcmd against shared runtime.

* Mon Nov 01 1999 Juergen Pfeifer <juergen@gnuada.org>
- Publish as Release 3

* Sun Oct 31 1999 Juergen Pfeifer <juergen@gnuada.org>
- Remove symlinks gnat and gnu-Ada to ada base directory
- Install also the ARM info file
- Remove EMACSLOADPATH setting from gnat.*sh; this was braindamage and
  causes big problems.
- at installtime look for mkinfodir and execute it with the
  correct INFOPATH to add our info files to the directory
- Change quoting in csh scripts.

* Sun Oct 31 1999 Juergen Pfeifer <juergen@gnuada.org>
- Fixed build architecture handling
- Published as Release 2

* Sat Oct 30 1999 PKG_AUTHOT <juergen@gnuada.org>
- Fix use of dvips in build script (run as filter).
- Make sure we can build on Redhat 5.1 and do the build there.
- Add our own info dir and modify startup scripts to set
  INFOPATH accordingly
- Fixed a few more places where gcc is mentioned instead of gnatgcc

* Fri Oct 29 1999 PKG_AUTHOT <juergen@gnuada.org>
- Published as Release 1

* Sun Oct 10 1999 Juergen Pfeifer <juergen@gnuada.org>
- First version of 3.12p created
